#include "testApp.h"
#include "particle.h"

#include "ofMain.h"

// comparison routine for sort...
bool comparisonFunction(  particle * a, particle * b ) { 
	return a->pos.x < b->pos.x; 
}              
      

//--------------------------------------------------------------
void testApp::setup(){

    for (int i = 0; i < 3000; i++){
        particle * p = new particle();
        myParticles.push_back(p);
        myParticles[i]->pos.set(ofRandom(0,ofGetWidth()),ofRandom(0,ofGetHeight()));
        myParticles[i]->vel.set(0,0);
    }
	
	ofSetCircleResolution(6);
	ofSetRectMode(OF_RECTMODE_CENTER);
}

//--------------------------------------------------------------
void testApp::update(){
	
	//cout << ofGetFrameRate() << endl;
	
	// sort all the particle
	sort( myParticles.begin(), myParticles.end(), comparisonFunction );               // sort them!
	
	
	
	ofBackground(0,0,0); //Grey background, NY style
	
    for (int i = 0; i < myParticles.size(); i++){
        myParticles[i]->resetForce();

    }
	
	
	for (int i = 0; i < myParticles.size(); i++){
		for (int j = i-1; j >= 0; j--){
			if ( fabs(myParticles[j]->pos.x - myParticles[i]->pos.x) >  10) break;
			
			myParticles[i]->addClockwiseForce(*myParticles[j],5,1.1f);
			//myParticles[i]->addRepulsionForce( *myParticles[j],10,1.1f);
		}
    }
	
	
    for (int i = 0; i < myParticles.size(); i++){
		myParticles[i]->addAttractionForce( 500,500,1500,0.01);
		myParticles[i]->addAttractionForce( mouseX,mouseY,80,0.03);
		//myParticles[i]->addRepulsionForce( mouseX,mouseY,50,1.7);
		
		myParticles[i]->addDampingForce();
        myParticles[i]->update();
	}
}

//--------------------------------------------------------------
void testApp::draw(){
	
	//ofSetColor(255,255,255);
	// then draw:
	
	int mouseDist;		// distance each particles is from the mouse, calculated in i-loop

	int mappedColor1;	// particle's color based on distance from mouse, set in i-loop
	int mappedColor2;	// particle's color based on distance from mouse, set in i-loop
	int mappedColor3;	// particle's color based on distance from mouse, set in i-loop
	
	int mappedAlpha;	// particle's opacity based on distance from mouse, set in i-loop
	int maxDist = 200;	// distance from mouse within which particles can be seen (i.e. has alpha)
	
	// connect neighboring particles based on sort
	//ofEnableAlphaBlending();
	//ofBeginShape();
	
	
	sinSize = ofMap(sin(ofGetElapsedTimef()), -1, 1, 2, 4);
	
	for (int i = 0; i < myParticles.size(); i++){
		
	
		mouseDist = ofDist(mouseX, mouseY, myParticles[i]->pos.x, myParticles[i]->pos.y);
		//mappedColor = ofMap(mouseDist, 1, 200, 1, 255);
		mappedColor1 = ofMap(mouseDist, 1, maxDist, 255, 1);
		mappedColor2 = ofMap(mouseDist, 1, maxDist, 245, 1);
		mappedColor3 = ofMap(mouseDist, 1, maxDist, 115, 1);
		
		if (mouseDist < maxDist+1) {
			mappedAlpha = ofMap(mouseDist, 1, maxDist, 255, 1);
		}
		
		else {
			mappedAlpha = 0;
		}
		
		ofSetColor(mappedColor1, mappedColor2, mappedColor3, mappedAlpha);
		myParticles[i]->draw(2);
	
		// draw left wing
//		ofBeginShape();
//		ofEnableAlphaBlending();
//
//		ofVertex(myParticles[i]->pos.x, myParticles[i]->pos.y);
//		ofVertex(myParticles[i]->pos.x-3, myParticles[i]->pos.y-1);
//		ofVertex(myParticles[i]->pos.x-3, myParticles[i]->pos.y+1);
//		
//		ofEndShape();
//		ofDisableAlphaBlending();
//
		//ofSetColor(255, 255, 255);
		//ofVertex(myParticles[i]->pos.x, myParticles[i]->pos.y);
		
	 }

	//ofEndShape();
	//ofDisableAlphaBlending();

	
	
}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){
   
}
//--------------------------------------------------------------
void testApp::keyReleased  (int key){

}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(){
	
}
